/*	injection_isrs.c

	Copyright 2008 Fred Cooke

	This file is part of the FreeEMS project.

	FreeEMS software is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	FreeEMS software is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with any FreeEMS software.  If not, see <http://www.gnu.org/licenses/>.

	We ask that if you make any changes to this file you send them upstream to us at admin@diyefi.org

	Thank you for choosing FreeEMS to run your engine! */

#include "injection_isrs.h"

/* Staged control algorithms for PIT2 and PIT3 */
/* Staged injection switch on timer */
void StagedOnISR(void){
	// clear the flag
	PITINTE |= 0x04;

	// bit bang on the correct injector channel
	// TODO figure out which channel and switch it
	// TODO set the flag for that channel
	
	// if there are other staged channels pending, schedule them and adjust the data
	// TODO 
	
	/* If staged injection needs the end point scheduled, do it now (otherwise it will turn off naturally with the main injector) */
	if(!(coreSettingsA & STAGED_END)){
		// TODO schedule the end of staged injection with PIT 3
	}
	
	/* Clear the PIT2 flag */
	// TODO
}

/* Staged injection switch off timer */
void StagedOffISR(void){
	// clear the flag
	PITINTE |= 0x08;
	
	// bit bang off the correct injector channel
	// TODO figure out which channel and switch it
	// TODO set the flag for that channel
	
	// if there are other staged channels pending, schedule them and adjust the data
	// TODO 
	
	/* Clear the PIT3 flag */
	// TODO 
}


/* Define the variables correctly for each channel then import the code */

/* Channel 1 */
#define INJECTOR_CHANNEL_NUMBER 0
#define InjectorXISR Injector1ISR
//#define channelXLatency channel1Latency
//#define channelXMainPulseWidth channel1MainPulseWidth
//#define MAINXCTL MAIN1CTL
//#define MAINXTIME MAIN1TIME 
//#define MAINXON MAIN1ON 
//#define MAINXOFF MAIN1OFF
//#define MAINXGOLOW MAIN1GOLOW
//#define MAINXGOHIGH MAIN1GOHIGH
//#define MAINXDISABLE MAIN1DISABLE
#define STAGEDXON STAGED1ON
#define STAGEDXOFF STAGED1OFF
//#define mainXHolding main1Holding
//#define injectorXRuntime injector1Runtime
#include "injector_isr.c"
#undef InjectorXISR
//#undef channelXLatency
//#undef channelXMainPulseWidth
//#undef MAINXCTL
//#undef MAINXTIME
//#undef MAINXON
//#undef MAINXOFF
//#undef MAINXGOLOW
//#undef MAINXGOHIGH
//#undef MAINXDISABLE
#undef STAGEDXON
#undef STAGEDXOFF
//#undef mainXHolding
//#undef injectorXRuntime
#undef INJECTOR_CHANNEL_NUMBER

/* Channel 2 */
#define INJECTOR_CHANNEL_NUMBER 1
#define InjectorXISR Injector2ISR
//#define channelXLatency channel2Latency
//#define channelXMainPulseWidth channel2MainPulseWidth
//#define MAINXCTL MAIN2CTL
//#define MAINXTIME MAIN2TIME 
//#define MAINXON MAIN2ON 
//#define MAINXOFF MAIN2OFF
//#define MAINXGOLOW MAIN2GOLOW
//#define MAINXGOHIGH MAIN2GOHIGH
//#define MAINXDISABLE MAIN2DISABLE
#define STAGEDXON STAGED2ON
#define STAGEDXOFF STAGED2OFF
//#define mainXHolding main2Holding
//#define injectorXRuntime injector2Runtime
#include "injector_isr.c"
#undef InjectorXISR
//#undef channelXLatency
//#undef channelXMainPulseWidth
//#undef MAINXCTL
//#undef MAINXTIME
//#undef MAINXON
//#undef MAINXOFF
//#undef MAINXGOLOW
//#undef MAINXGOHIGH
//#undef MAINXDISABLE
#undef STAGEDXON
#undef STAGEDXOFF
//#undef mainXHolding
//#undef injectorXRuntime
#undef INJECTOR_CHANNEL_NUMBER

/* Channel 3 */
#define INJECTOR_CHANNEL_NUMBER 2
#define InjectorXISR Injector3ISR
//#define channelXLatency channel3Latency
//#define channelXMainPulseWidth channel3MainPulseWidth
//#define MAINXCTL MAIN3CTL
//#define MAINXTIME MAIN3TIME 
//#define MAINXON MAIN3ON 
//#define MAINXOFF MAIN3OFF
//#define MAINXGOLOW MAIN3GOLOW
//#define MAINXGOHIGH MAIN3GOHIGH
//#define MAINXDISABLE MAIN3DISABLE
#define STAGEDXON STAGED3ON
#define STAGEDXOFF STAGED3OFF
//#define mainXHolding main3Holding
//#define injectorXRuntime injector3Runtime
#include "injector_isr.c"
#undef InjectorXISR
//#undef channelXLatency
//#undef channelXMainPulseWidth
//#undef MAINXCTL
//#undef MAINXTIME
//#undef MAINXON
//#undef MAINXOFF
//#undef MAINXGOLOW
//#undef MAINXGOHIGH
//#undef MAINXDISABLE
#undef STAGEDXON
#undef STAGEDXOFF
//#undef mainXHolding
//#undef injectorXRuntime
#undef INJECTOR_CHANNEL_NUMBER

/* Channel 4 */
#define INJECTOR_CHANNEL_NUMBER 3
#define InjectorXISR Injector4ISR
//#define channelXLatency channel4Latency
//#define channelXMainPulseWidth channel4MainPulseWidth
//#define MAINXCTL MAIN4CTL
//#define MAINXTIME MAIN4TIME 
//#define MAINXON MAIN4ON 
//#define MAINXOFF MAIN4OFF
//#define MAINXGOLOW MAIN4GOLOW
//#define MAINXGOHIGH MAIN4GOHIGH
//#define MAINXDISABLE MAIN4DISABLE
#define STAGEDXON STAGED4ON
#define STAGEDXOFF STAGED4OFF
//#define mainXHolding main4Holding
//#define injectorXRuntime injector4Runtime
#include "injector_isr.c"
#undef InjectorXISR
//#undef channelXLatency
//#undef channelXMainPulseWidth
//#undef MAINXCTL
//#undef MAINXTIME
//#undef MAINXON
//#undef MAINXOFF
//#undef MAINXGOLOW
//#undef MAINXGOHIGH
//#undef MAINXDISABLE
#undef STAGEDXON
#undef STAGEDXOFF
//#undef mainXHolding
//#undef injectorXRuntime
#undef INJECTOR_CHANNEL_NUMBER

/* Channel 5 */
#define INJECTOR_CHANNEL_NUMBER 4
#define InjectorXISR Injector5ISR
//#define channelXLatency channel5Latency
//#define channelXMainPulseWidth channel5MainPulseWidth
//#define MAINXCTL MAIN5CTL
//#define MAINXTIME MAIN5TIME 
//#define MAINXON MAIN5ON 
//#define MAINXOFF MAIN5OFF
//#define MAINXGOLOW MAIN5GOLOW
//#define MAINXGOHIGH MAIN5GOHIGH
//#define MAINXDISABLE MAIN5DISABLE
#define STAGEDXON STAGED5ON
#define STAGEDXOFF STAGED5OFF
//#define mainXHolding main5Holding
//#define injectorXRuntime injector5Runtime
#include "injector_isr.c"
#undef InjectorXISR
//#undef channelXLatency
//#undef channelXMainPulseWidth
//#undef MAINXCTL
//#undef MAINXTIME
//#undef MAINXON
//#undef MAINXOFF
//#undef MAINXGOLOW
//#undef MAINXGOHIGH
//#undef MAINXDISABLE
#undef STAGEDXON
#undef STAGEDXOFF
//#undef mainXHolding
//#undef injectorXRuntime
#undef INJECTOR_CHANNEL_NUMBER

/* Channel 6 */
#define INJECTOR_CHANNEL_NUMBER 5
#define InjectorXISR Injector6ISR
//#define channelXLatency channel6Latency
//#define channelXMainPulseWidth channel6MainPulseWidth
//#define MAINXCTL MAIN6CTL
//#define MAINXTIME MAIN6TIME 
//#define MAINXON MAIN6ON 
//#define MAINXOFF MAIN6OFF
//#define MAINXGOLOW MAIN6GOLOW
//#define MAINXGOHIGH MAIN6GOHIGH
//#define MAINXDISABLE MAIN6DISABLE
#define STAGEDXON STAGED6ON
#define STAGEDXOFF STAGED6OFF
//#define mainXHolding main6Holding
//#define injectorXRuntime injector6Runtime
#include "injector_isr.c"
#undef InjectorXISR
//#undef channelXLatency
//#undef channelXMainPulseWidth
//#undef MAINXCTL
//#undef MAINXTIME
//#undef MAINXON
//#undef MAINXOFF
//#undef MAINXGOLOW
//#undef MAINXGOHIGH
//#undef MAINXDISABLE
#undef STAGEDXON
#undef STAGEDXOFF
//#undef mainXHolding
//#undef injectorXRuntime
#undef INJECTOR_CHANNEL_NUMBER

/* If switching to 8 OC channels with non-IC engine input, place two more sets of defines here :-) (along with all the other mods needed of course) */ 
